package com.afp.ordermanagement.model;

import lombok.Data;
import lombok.NoArgsConstructor;
import org.springframework.data.annotation.Id;
import org.springframework.data.mongodb.core.mapping.Document;
import org.springframework.lang.NonNull;

import javax.validation.constraints.Email;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.Size;
import java.lang.reflect.Field;

import static java.util.Objects.isNull;

@Data
@NoArgsConstructor
@Document(collection = "managers")
public class Manager {
    @Id
    private String id;
    private String managerId;
//    @NotBlank

    @NonNull
    @Size(min = 1, max = 250, message = "firstName & lastName must be between 1 & 250 characters")
    private String firstName, lastName;
    @Email
    private String email;
    private String googleId;
    private String imageUrl;


    static public Manager combine(Manager target, Manager source) {
        try {
            for (Field field: Manager.class.getDeclaredFields()) {
                String fieldName = field.getName();
                Object sourceValue = field.get(source);
                if (!isNull(sourceValue) && !fieldName.equals("id"))
                    field.set(target, sourceValue);
            }
        } catch (Exception ignore) { }

        return target;
    }
}
